<?php
      class Time_
      {
           var $mysql_select_database;
           
           function Time_()
           {
                global $mass_settings;
                switch($mass_settings["type_db"])
                {
                   case "sqlite":
                      $this->sqlite_clear_db();
                      break;

                   case "mysql":
                      $this->mysql_select_database = true;
                      $this->mysql_clear_db();
                      break;
                      
                   case "files":
                      $this->clear_files();
                      break;
                 }
           }
           
           function sqlite_clear_db()
           {
           		global $ini, $mass_settings;
           		
                if(!function_exists("sqlite_open")){
                    echo "On this host database Sqlite don't use";
                    exit();
                }
            	if(!isset($GLOBALS['mass_settings']['module_id'])) {
            		return false;
            	}
                $modsDataDir  = '../data/';
        		$forumDataDir = $modsDataDir.$GLOBALS['mass_settings']['module_id'].'/';
                $sqlite_file  = $forumDataDir."dump_forum";
				
				if(!file_exists($sqlite_file)) return false;
				
                $con = sqlite_open($sqlite_file) or die("Not connection to Database");
                $time = time();
                $last_time = 60*60*24*30.3*$ini['store_monthes'];

                $sql = "DELETE FROM list_topics WHERE $time-time_create>$last_time";
                $result = sqlite_query($sql,$con);
                
                $sql = "DELETE FROM list_answers WHERE $time-time_create>$last_time";
                $result = sqlite_query($sql,$con);
                
                sqlite_close($con);
            }
            
            function setVar()
            {
              $this->mysql_select_database = false;
            }

            function mysql_clear_db()
            {
                global $ini,$mass_settings;

                if(!function_exists("mysql_connect")) {
                    echo "mysql_error";
                    exit();
                }
                if(isset($mass_settings["port_db"]) && $mass_settings["port_db"]!="")                                                                   
                   $con = @mysql_connect($mass_settings["host_db"].":".$mass_settings["port_db"],$mass_settings["user_db"],$mass_settings["passwd_db"]) or $this->setVar();
                else
                   $con = @mysql_connect($mass_settings["host_db"], $mass_settings["user_db"], $mass_settings["passwd_db"]) or $this->setVar();

                if(!$this->mysql_select_database) return;
                @mysql_select_db($mass_settings["db_name"]) or $this->setVar();
                if(!$this->mysql_select_database) return;
                
                
                $time = time();
                $last_time = 60*60*24*30.3*$ini['store_monthes'];

                $sql = "DELETE FROM ".$mass_settings['module_id']."_list_topics WHERE $time-time_create>$last_time";
                $result = @mysql_query($sql,$con);

                $sql = "DELETE FROM ".$mass_settings['module_id']."_list_answers WHERE $time-time_create>$last_time";
                $result = @mysql_query($sql,$con);
                mysql_close($con);
            }
            
            function clear_files()
            {
                global $ini;
        		if(!isset($GLOBALS['mass_settings']['module_id'])) {
        			return false;
        		}
                $modsDataDir='../data/';
        		$forumDataDir=$modsDataDir.$GLOBALS['mass_settings']['module_id'].'/';
            	$file_topics  = $forumDataDir.'topics.txt';
            	$file_answers = $forumDataDir.'answers.txt';
				
               if(file_exists($file_topics) && file_exists($file_answers) && $ini['store_monthes']>0)
               {
                   $topics_content = $this->get_file_content($file_topics);
                   $topics = unserialize($topics_content);
                   if (empty($topics)) return false; 

                   $answers_content = $this->get_file_content($file_answers);
                   $answers = unserialize($answers_content);
                   if (empty($answers)) $answers = array(); 

                   $old_topic_keys = array(); 
                   $old_answer_keys = array(); 
                   foreach ($topics as $t_key=>$topic) 
                   {
                       if (time()-$topic[0] < 60*60*24*30.3*$ini['store_monthes']) 
                       {
                                 continue;  
                       }
                       $no_new_answers = true;
                       $tmp_answer_keys = array();
                              foreach ($answers as $a_key=>$answer) {
                                       if ($answer[1]==$topic[0] ) {
                                if (time()-$answer[1] < 60*60*24*30.3*$ini['store_monthes']) 
                                {
                                         $no_new_answers = false;  
                                  break;
                                }    
                                $tmp_answer_keys[] = $a_key; 
                                       }
                              }
                       if ($no_new_answers) 
                       {
                           unset($topics[$t_key]);
                           if (!empty($tmp_answer_keys)) 
                           {
                               foreach ($tmp_answer_keys as $val) unset($answers[$val]); 
                           }
                       }
                   }

                   $this->set_file_content($file_topics, serialize($topics));
                   $this->set_file_content($file_answers, serialize($answers));
                }
            }
            
            function get_file_content($path_file)
            {
                 $file_content = implode("", file($path_file));
                 $file_content = str_replace("\n","",$file_content);
                 $file_content = str_replace("\r","",$file_content);
                 $file_content = str_replace("\t","",$file_content);
                 $file_content = trim($file_content);
                 return $file_content;
            }

            function set_file_content($path_file,$content)
            {
                 $fp = fopen($path_file,"w");
                 fwrite($fp, $content);
                 fclose($fp);
            }
      }
?>
